# -*- coding: utf-8; -*-
################################################################################
#
#  Rattail -- Retail Software Framework
#  Copyright © 2010-2023 Lance Edgar
#
#  This file is part of Rattail.
#
#  Rattail is free software: you can redistribute it and/or modify it under the
#  terms of the GNU General Public License as published by the Free Software
#  Foundation, either version 3 of the License, or (at your option) any later
#  version.
#
#  Rattail is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
#  details.
#
#  You should have received a copy of the GNU General Public License along with
#  Rattail.  If not, see <http://www.gnu.org/licenses/>.
#
################################################################################
"""
Tailbone Handler
"""

from __future__ import unicode_literals, absolute_import

from rattail.app import GenericHandler


class TailboneHandler(GenericHandler):
    """
    Base class and default implementation for Tailbone handler.
    """

    def get_menu_handler(self, **kwargs):
        """
        Get the configured "menu" handler.

        :returns: The :class:`~tailbone.menus.MenuHandler` instance
           for the app.
        """
        if not hasattr(self, 'menu_handler'):
            spec = self.config.get('tailbone.menus', 'handler',
                                   default='tailbone.menus:MenuHandler')
            Handler = self.app.load_object(spec)
            self.menu_handler = Handler(self.config)
        return self.menu_handler
